Package com.smartgwt.client.types

# Enum RowCountStatus

java.lang.Object
java.lang.Enum<RowCountStatus>
com.smartgwt.client.types.RowCountStatus

All Implemented Interfaces:
  `ValueEnum`, `Serializable`, `Comparable<RowCountStatus>`, `Constable`

public enum RowCountStatus extends Enum<RowCountStatus> implements ValueEnum
Enumerated status indicating whether a ResultSet has an accurate `ResultSet.getRowCount()` row count for the data set.

This is a feature associated with `progressive loading of data`. When progressive loading is active, the `length` may not indicate the true size of the data set. In this case a different total row count may be maintained by the ResultSet data object and retrieved via `ResultSet.getRowCount()`. This status code indicates whether this row count is an exact value or not.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `APPROXIMATE`
  The current row count is an approximation.
  `EXACT`
  The size of the data set is known and the current row count is accurate.
  `LOADING`
  This value indicates that the ResultSet is waiting for an active `row count fetch` to complete.
  `MAXIMUM`
  The current row count is a maximum - there are no more than this many records in the data set.
  `MINIMUM`
  The current row count is a minimum - there are at least this many records in the data set.
  `RANGE`
  The data object knows the total number of records in the data set lies within a particular range.
  `UNKNOWN`
  The current row count is unknown.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getValue()`
  `static RowCountStatus`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static RowCountStatus[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### EXACT

    public static final RowCountStatus EXACT
    The size of the data set is known and the current row count is accurate. This always will be the case if `progressiveLoading` is not active. If progressiveLoading is active, we may have an accurate row count in the following scenarios:
    - `ResultSet.setFullLength()` was explicitly invoked to tell the resultSet its total length.
      In this case `ResultSet.getLength()` will return the same value as `ResultSet.getRowCount()`
    - The user has scrolled all the way to the true end of the progressively loaded data set such that the length is now known.
      In this case `ResultSet.getLength()` will return the same value as `ResultSet.getRowCount()`
    - A successful row count fetch was performed via `ResultSet.fetchRowCount()`.
      In this case `ResultSet.getLength()` will return the same value as `ResultSet.getRowCount()` if `ResultSet.applyRowCountToLength` is true, otherwise the values may differ.
    - The dataSource fetch response to a request for rows within the resultSet included a `DSResponse.estimatedTotalRows` value with an exact value
      In this case `ResultSet.getLength()` will return the same value as `ResultSet.getRowCount()` if `ResultSet.applyRowCountToLength` is true, otherwise the values may differ.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "exact".

  - ### UNKNOWN

    public static final RowCountStatus UNKNOWN
    The current row count is unknown. This value indicates `ResultSet.lengthIsKnown()` returns false.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "unknown".

  - ### LOADING

    public static final RowCountStatus LOADING
    This value indicates that the ResultSet is waiting for an active `row count fetch` to complete.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "loading".

  - ### MINIMUM

    public static final RowCountStatus MINIMUM
    The current row count is a minimum - there are at least this many records in the data set. Note that when `progressiveLoading` is active, this will be the status if no explicit `DSResponse.estimatedTotalRows` was available, so `DSResponse.totalRows` is a minimum, or if `DSResponse.estimatedTotalRows` contained a value in the format `"[rowCount]+"`.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "minimum".

  - ### APPROXIMATE

    public static final RowCountStatus APPROXIMATE
    The current row count is an approximation. This will be the status if `progressiveLoading` is active and a fetch request contained an explicit `DSResponse.estimatedTotalRows` in the format `"~[rowCount]"`.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "approximate".

  - ### MAXIMUM

    public static final RowCountStatus MAXIMUM
    The current row count is a maximum - there are no more than this many records in the data set. This will be the status if `progressiveLoading` is active and a fetch request contained an explicit `DSResponse.estimatedTotalRows` in the format `"-[rowCount]"`.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "maximum".

  - ### RANGE

    public static final RowCountStatus RANGE
    The data object knows the total number of records in the data set lies within a particular range. In this case `ListGrid.getRowCountRange()` may be used to retrieve the upper and lower bound of this range, and `ListGrid.getRowCount()` will return the lower bound. This will be the status if `progressiveLoading` is active and a fetch request contained an explicit `DSResponse.estimatedTotalRows` in the format `"[minRowCount]-[maxRowCount]"`.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "range".

- ## Method Details

  - ### values

    public static RowCountStatus[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static RowCountStatus valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getValue

    public String getValue()
    Specified by:
      `getValue` in interface `ValueEnum`